%define tar_version 2.8b
Name:           jabref
Version:        2.8
Release:        0.1.b%{?dist}
Summary:        Graphical frontend to manage BibTeX bibliographical databases
License:        GPLv2+ and BSD
Group:          Applications/Publishing
Url:            http://jabref.sourceforge.net/

BuildArch: noarch

Source0:        http://downloads.sourceforge.net/%{name}/JabRef-%{tar_version}-src.tar.bz2
Source1:        jabref.desktop
# Obtained as follows (on 2012-01-25):
# - git clone git://jabref.git.sourceforge.net/gitroot/jabref/jabref/
# - cd jabref
# - tar cvfj jpfcodegen-20120125.tbz jpfcodegen/
Source2:        jpfcodegen-20120125.tbz

# Don't package other classes into the jar
Patch0:  jabref-2.8b-build_xml.patch
# Regenerate the antlr parser with a more modern version of antlr3
Patch1:  jabref-2.8b-antlr.patch
# Remove the calls to the bundled "wsi" packages
Patch2:  jabref-2.8b-remove-wsi.patch
# Remove the explicit use of the Windows L&F
Patch3:  jabref-2.4.2-remove-windows.patch
# Fix a weird issue where a field isn't available
Patch4:  jabref-2.4.2-pane.patch
# Remove all uses of "SPL"
Patch5:  jabref-2.8b-remove-spl.patch
# Update to use the newest glazedlists API
Patch6:  jabref-2.8b-TableComparator.patch
# Update to use the newest glazedlists API
Patch7:  jabref-2.8b-Arrays.patch
# Fix the jpfcodegen build to use system jars
Patch8:  jabref-2.8b-jpfcodegen-build.patch

BuildRequires:  jpackage-utils
BuildRequires:  java-devel
BuildRequires:  ant

BuildRequires:  antlr3-java
BuildRequires:  antlr3-tool
BuildRequires:  antlr-tool
BuildRequires:  apache-commons-logging
BuildRequires:  glazedlists
BuildRequires:  jempbox
BuildRequires:  jgoodies-forms
BuildRequires:  jgoodies-looks
BuildRequires:  jgoodies-looks-demo
BuildRequires:  jpf
BuildRequires:  libreoffice-core
BuildRequires:  microba
BuildRequires:  pdfbox
BuildRequires:  ritopt
BuildRequires:  spin
BuildRequires:  stringtemplate
BuildRequires:  velocity


Requires:       java
Requires:       jpackage-utils

Requires:       antlr3-java
Requires:       antlr3-tool
Requires:       antlr-tool
Requires:       apache-commons-logging
Requires:       glazedlists
Requires:       jempbox
Requires:       jgoodies-forms
Requires:       jgoodies-looks
Requires:       jgoodies-looks-demo
Requires:       jpf
Requires:       microba
Requires:       pdfbox
Requires:       ritopt
Requires:       spin

%description
JabRef is a graphical front-end to manage BibTeX databases, the standard
LaTeX bibliography reference format. JabRef is build to be platform
independent (requires Java >= 1.4.2). It merges and extends the
functionalities of BibKeeper (Morten O. Alver) and JBibtexManager (Nizar
Batada).

%prep
%setup -q -n %{name}-%{tar_version}

# Don't do the "unjarlib" task as part of the build
%patch0 -p1

# Fix errors in the antlr parser
%patch1 -p1

# Remove bundled packages and clean up the source
rm -rf src/java/com src/java/wsi src/java/gnu
%patch2 -p1
%patch3 -p1
%patch4 -p1

# Remove "sciplore" client
rm -rf src/java/net/sf/jabref/spl src/java/spl
%patch5 -p1

# Update to newest glazedlists API
%patch6 -p1

# Fix an import bug
%patch7 -p1

# Unpack the "jpfcodegen" package and patch its build not to use bundled
# libs
%setup -q -n %{name}-%{tar_version} -T -D -a 2
%patch8 -p1

# Fix one file permission
chmod a-x src/txt/gpl2.txt

# Remove all pre-built jar files, but leave the directory structure and the
# EndNote filters
find -name '*.class' -exec rm -f '{}' \;
find -name '*.jar' -exec rm -f '{}' \;


%build
# Fix errors in the antlr parser and regenerate
rm -f src/java/net/sf/jabref/bst/Bst*.java
mv src/java/net/sf/jabref/bst/bst.g src/java/net/sf/jabref/bst/Bst.g
java -cp `build-classpath antlr antlr3 antlr3-runtime stringtemplate` org.antlr.Tool src/java/net/sf/jabref/bst/Bst.g

# Build jpfcodegen
pushd jpfcodegen
export CLASSPATH=`build-classpath jpf jpf-boot commons-logging velocity`
ant jars
popd

# System jars
export CLASSPATH=`build-classpath jgoodies-looks jgoodies-forms spin glazedlists antlr antlr3 antlr3-runtime microba pdfbox ritopt jgoodies-looks-demo jempbox apache-commons-logging jpf jpf-boot`
# Additional jars from LibreOffice -- build time only
export CLASSPATH=$CLASSPATH:%{_libdir}/libreoffice/ure/share/java/juh.jar
export CLASSPATH=$CLASSPATH:%{_libdir}/libreoffice/ure/share/java/jurt.jar
export CLASSPATH=$CLASSPATH:%{_libdir}/libreoffice/ure/share/java/ridl.jar
export CLASSPATH=$CLASSPATH:%{_libdir}/libreoffice/basis3.4/program/classes/unoil.jar
# Also use the JPF code generator we just built
export CLASSPATH=$CLASSPATH:jpfcodegen/JPFCodeGenerator-0.4.jar
ant

%install
rm -rf $RPM_BUILD_ROOT
# Install Java stuff
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -pm 644 build/lib/JabRef-%{tar_version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}.jar
install -pm 644 jpfcodegen/JPFCodeGenerator-0.4-rt.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}

# Install desktop file, icon, and shell script
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/icons/hicolor/48x48/apps/
cp -p src/images/JabRef-icon-48.png \
        ${RPM_BUILD_ROOT}%{_datadir}/icons/hicolor/48x48/apps/jabref.png
desktop-file-install \
        --dir=${RPM_BUILD_ROOT}%{_datadir}/applications \
        %{SOURCE1}
%jpackage_script net.sf.jabref.JabRefMain "" "" antlr:antlr3:antlr3-runtime:apache-commons-logging:glazedlists:jempbox:jgoodies-forms:jgoodies-looks:jgoodies-looks-demo:jpf:jpf-boot:microba:pdfbox:ritopt:spin:jabref jabref true

%post -p /usr/bin/update-desktop-database

%postun -p /usr/bin/update-desktop-database

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc src/txt/CHANGELOG src/txt/README src/txt/TODO src/txt/*.txt
%{_datadir}/applications/%{name}.desktop
%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%{_javadir}/%{name}
%attr(755,root,root) %{_bindir}/%{name}

%changelog
* Wed Jan 25 2012 Mary Ellen Foster <mefoster at gmail.com> - 2.8-1
- Initial package
